package upv.pauchorroyanguas.com.encryptorpcy;

import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.res.Resources;
import android.os.AsyncTask;
import android.os.Environment;
import android.os.Handler;
import android.preference.PreferenceManager;
import android.support.design.widget.FloatingActionButton;
import android.support.v7.app.ActionBarActivity;
import android.os.Bundle;
import android.support.v7.app.AlertDialog;
import android.util.Log;
import android.util.SparseBooleanArray;
import android.view.ActionMode;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.AbsListView;
import android.widget.AdapterView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

import org.apache.commons.lang3.StringUtils;

import java.io.File;
import java.util.Vector;

import upv.pauchorroyanguas.com.encryptorpcy.Exception.CryptoException;
import upv.pauchorroyanguas.com.encryptorpcy.Utils.CryptoUtils;
import upv.pauchorroyanguas.com.encryptorpcy.Utils.FileUtil;
import upv.pauchorroyanguas.com.encryptorpcy.Utils.FolderUtil;
import upv.pauchorroyanguas.com.encryptorpcy.Utils.IntentUtil;
import upv.pauchorroyanguas.com.encryptorpcy.adapter.ExplorerFoldersAdapterArray;


/**
 * Author: Pau Chorro
 * Date: 01/11/15
 *
 * Folders and files decrypted, button to add more files
 *
 */
public class MainActivity extends ActionBarActivity {

    final int VIDEO = 0;
    final int PDF = 1;
    final int IMAGE = 2;
    final int AUDIO = 3;
    final int TXT = 4;
    final int NO_LAUNCH = 999;

    //Copy and cut
    boolean copy;
    SparseBooleanArray selected;

    //Vector List Folders
    Vector<String> listNameFolders;
    Vector<String> listCopyFiles;
    //Vector<String> listCutFiles;

    ProgressDialog pdOpenFile;

    //Adapters
    //ExplorerFoldersAdapter adapterLV;
    ExplorerFoldersAdapterArray listviewadapter;

    //Views
    ListView lvFolders;

    //Constants Folders
    private static String mainPath = Environment.getExternalStorageDirectory() +
            "/";
    private static String mainFolder = ".EncryptorPCY";
    private String currentFolder = ".EncryptorPCY"; //The mainFolder is the current folder by default
    private String currentPath = ".EncryptorPCY"; //The current path is the mainFolder by default
    private String currentPathCopy = ".EncryptorPCY";

    //NUM const
    private static final int GO_BACK = 0;
    private static final int MENUOPTIONSACTIVITY_NEWFOLDER_REQUESTCODE = 1234;
    private static final int MENU_ITEM_RENAME = 2;

    private static int RESULT_ENCRYPT = 450;
    public static int RESULT_ENCRYPT_IMAGE = 451;
    private static int TOTAL_FILE_LENGTH_SUPORT = 4424784;

    public static int ENCRYPT_IMAGE = 0;
    public static int ENCRYPT_FILE = 1;

    //VIEWS
    FloatingActionButton fabSend;
    FloatingActionButton fabCancel;
    LinearLayout progressBarGroup;
    TextView tvOperation;

    private Handler customHandler = new Handler();

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        //Configure theme
        SharedPreferences pref = PreferenceManager
                .getDefaultSharedPreferences(this);
        String themeName = pref.getString("themeApp", "1");

        if(themeName.equalsIgnoreCase("0")) {

            setTheme(R.style.ThemeEncryptorPCY);
        }
        else if(themeName.equalsIgnoreCase("1"))
        {
            setTheme(R.style.ThemeEncryptorPCYLightBlue);
        }
        else
        {
            setTheme(R.style.ThemeEncryptorPCYYellow);
        }

        setContentView(R.layout.activity_main);

        listCopyFiles = new Vector<String>();

        fabSend = (FloatingActionButton) findViewById(R.id.fabSend);
        fabCancel = (FloatingActionButton) findViewById(R.id.fabCancel);

        progressBarGroup = (LinearLayout) findViewById(R.id.progressBarGroup);
        tvOperation = (TextView) findViewById(R.id.tvOperation);

        fabSend.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                new OperationFiles().execute();
            }
        });

        fabCancel.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                listCopyFiles.clear();

                fabSend.setVisibility(View.GONE);
                fabCancel.setVisibility(View.GONE);
            }
        });


        FloatingActionButton myFab = (FloatingActionButton) findViewById(R.id.fab);
        myFab.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                launchMenuOptionsActivity(null);
            }
        });

        //List view
        listNameFolders = FileUtil.getNameFilesAndDirectories(mainFolder);
        lvFolders = (ListView) findViewById(R.id.listFiles);

        //adapterLV = new ExplorerFoldersAdapter(this, listNameFolders);
        //lvFolders.setAdapter(adapterLV);

        listviewadapter = new ExplorerFoldersAdapterArray(getApplicationContext(), R.layout.adapter_listview_folders,
                listNameFolders, this);
        lvFolders.setAdapter(listviewadapter);

        lvFolders.setOnItemLongClickListener(new AdapterView.OnItemLongClickListener() {
            @Override
            public boolean onItemLongClick(AdapterView<?> parent, View view, int position, long id) {
                return false;
            }
        });

        /**
         * It will enable the Choice mode
         */
        lvFolders.setOnItemLongClickListener(new AdapterView.OnItemLongClickListener() {
            @Override
            public boolean onItemLongClick(AdapterView<?> parent, View view, int position, long id) {

                lvFolders.setChoiceMode(ListView.CHOICE_MODE_MULTIPLE_MODAL);

                return false;
            }
        });

        /**
         * ClickListener of the listview of folders
         */
        lvFolders.setOnItemClickListener(new AdapterView.OnItemClickListener() {


            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {

                /**
                 * If is clicked the first list item, is the go back position
                 */
                if(position == GO_BACK)
                {
                    //If the current path is the main Folder, it is not permitted go back
                    if(currentPath.equals(mainFolder)) {
                        Toast.makeText(getApplicationContext(),getStringResources(R.string.rootFileError), Toast.LENGTH_SHORT).show();
                    }
                    else
                    {
                        //Current path is equal to first to the last position of "/"
                        currentPath = currentPath.substring(0, currentPath.lastIndexOf("/"));
                        //If currentPath contains "/" is not the root folder --> mainFolder
                        //The current folder is the last position of "/" to the end of the string
                        if(currentPath.contains("/"))
                        {
                            currentFolder = currentPath.substring(currentPath.lastIndexOf("/") +1,
                                    currentPath.length()) ;

                            Log.e("LOG_MAINACTIVITY", currentFolder);
                        }
                        //If currentPath not contains "/" is the root folder
                        else
                        {
                            currentFolder = mainFolder;
                        }

                        //Refresh the list
                        //new GetNewListFolders().execute();
                        updateListView();
                    }
                }
                /*else if(position == (listNameFolders.size() - 1))
                {
                    //DO nothing
                }*/
                //Is clicked any one file or folder
                else
                {
                    String currentPathAux = currentPath;
                    currentPathAux += "/" + listNameFolders.elementAt(position);

                    //In case of it is not a folder it will be choosed anyone intent to open
                    if(!FolderUtil.isFolder(currentPathAux))
                    {
                        String nameFile = listNameFolders.elementAt(position);

                        String extension = FileUtil.getExtension(listNameFolders.elementAt(position));
                        extension = extension.toLowerCase();

                        String pathURI =  mainPath + currentPath  + "/" + nameFile;
                        switch(extension)
                        {
                            //SOUNDS or MUSIC
                            case "3gp":
                            case "mp3":
                                new OpenFiles(AUDIO, pathURI, getApplicationContext()).execute();
                                //IntentUtil.intentAudio(getApplicationContext(), pathURI);
                                break;
                            //VIDEOS
                            case "mov":
                            case "avi":
                            case "flv":
                            case "mp4":
                            case "mpg":
                                new OpenFiles(VIDEO, pathURI, getApplicationContext()).execute();
                                //IntentUtil.intentVideo(getApplicationContext(), pathURI);
                                break;
                            //IMAGES
                            case "jpg":
                            case "jpeg":
                            case "png":
                                new OpenFiles(IMAGE, pathURI, getApplicationContext()).execute();
                                //IntentUtil.intentImage(getApplicationContext(), pathURI);
                                break;
                            //GIF
                            case "gif":
                                new OpenFiles(IMAGE, pathURI, getApplicationContext()).execute();
                                //IntentUtil.intentImage(getApplicationContext(), pathURI);
                                break;
                            //TXT
                            case "txt":
                                new OpenFiles(TXT, pathURI, getApplicationContext()).execute();
                                //IntentUtil.intentTXT(getApplicationContext(), pathURI);
                                break;
                            //PDF
                            case "pdf":
                                new OpenFiles(PDF, pathURI, getApplicationContext()).execute();
                                //IntentUtil.intentPDF(getApplicationContext(), pathURI);
                                break;
                            //ELSE
                            default:
                                Toast.makeText(getApplicationContext(), getStringResources(R.string.cannotOpen), Toast.LENGTH_SHORT).show();
                                break;
                        }

                    }
                    //In case of it will be opened a folder, it will refresh the list with the items of
                    //the new folder. Fields currentPath and currentFolder will be uptated.
                    else
                    {
                        currentPath += "/" + listNameFolders.elementAt(position);
                        currentFolder = listNameFolders.elementAt(position);
                        //new GetNewListFolders().execute();
                        updateListView();
                    }
                }

            }
        });

        lvFolders.setMultiChoiceModeListener(new AbsListView.MultiChoiceModeListener() {
            @Override
            public void onItemCheckedStateChanged(ActionMode mode, int position, long id, boolean checked) {


                // Capture total checked items
                final int checkedCount = lvFolders.getCheckedItemCount();

                // Set the CAB title according to total checked items
                mode.setTitle(checkedCount + " " + getStringResources(R.string.selected));


                if(checkedCount != 1 && mode.getMenu().getItem(MENU_ITEM_RENAME).isVisible())
                {
                    mode.getMenu().getItem(MENU_ITEM_RENAME).setVisible(false);
                }
                else if(checkedCount == 1 && !mode.getMenu().getItem(MENU_ITEM_RENAME).isVisible())
                {
                    mode.getMenu().getItem(MENU_ITEM_RENAME).setVisible(true);
                }

                // Calls toggleSelection method from ListViewAdapter Class
                listviewadapter.toggleSelection(position);
            }

            @Override
            public boolean onCreateActionMode(ActionMode mode, Menu menu) {
                mode.getMenuInflater().inflate(R.menu.menu_main_activity2, menu);

                return true;
            }

            @Override
            public boolean onPrepareActionMode(ActionMode mode, Menu menu) {
                return false;
            }

            @Override
            public boolean onActionItemClicked(ActionMode mode, MenuItem item) {

                switch (item.getItemId()) {

                    //DELETE SELECTED FILES
                    case R.id.delete:

                        AlertDialog.Builder alertDialogDelete;
                        AlertDialog dialogDelete;

                        alertDialogDelete = new AlertDialog.Builder(MainActivity.this);

                        alertDialogDelete.setTitle(getStringResources(R.string.ConfirmDelete));

                        // Calls getSelectedIds method from ListViewAdapter Class
                        selected = listviewadapter
                                .getSelectedIds();

                        /**
                         * Positive Button, it will delete the files selected
                         * It will make a TOAST reporting what it will have done
                         */
                        alertDialogDelete.setPositiveButton(getStringResources(R.string.accept),
                                new DialogInterface.OnClickListener() {

                                    public void onClick(DialogInterface dialog, int which) {


                                        Toast.makeText(getApplicationContext(),
                                                getStringResources(R.string.AcceptConfirmDelete) + " " +
                                                        selected.size(),
                                                Toast.LENGTH_LONG).show();

                                        // Captures all selected ids with a loop
                                        for (int i = (selected.size() - 1); i >= 0; i--) {
                                            if (selected.valueAt(i)) {
                                                String selecteditem = listviewadapter
                                                        .getItem(selected.keyAt(i));
                                                // Remove selected items following the ids

                                                listviewadapter.remove(selecteditem);
                                            }
                                        }

                                        selected.clear();

                                    }
                                });

                        /**
                         * Negative Button, it will not delete the files selected
                         * It will make a TOAST reporting what it will have not done
                         */
                        alertDialogDelete.setNegativeButton(getStringResources(R.string.cancel),
                                new DialogInterface.OnClickListener() {

                                    public void onClick(DialogInterface dialog, int which) {

                                        Toast.makeText(getApplicationContext(),
                                                getStringResources(R.string.CancelConfirmDelete), Toast.LENGTH_LONG).show();
                                    }
                                });

                        dialogDelete = alertDialogDelete.show();

                        // Close CAB
                        mode.finish();

                        return true;
                    //COPY SELECTED FILES
                    case R.id.copy:

                        currentPathCopy = currentPath;

                        // Calls getSelectedIds method from ListViewAdapter Class
                        selected = listviewadapter
                                .getSelectedIds();
                        // Captures all selected ids with a loop
                        for (int i = (selected.size() - 1); i >= 0; i--) {
                            if (selected.valueAt(i)) {
                                String selecteditem = listviewadapter
                                        .getItem(selected.keyAt(i));
                                // Add selected items following the ids
                                listCopyFiles.add(selecteditem);

                            }
                        }

                        fabCancel.setVisibility(View.VISIBLE);
                        fabSend.setVisibility(View.VISIBLE);
                        copy = true;

                        // Close CAB
                        mode.finish();

                        return true;
                    //CUT SELECTED FILES
                    case R.id.cut:

                        currentPathCopy = currentPath;

                        // Calls getSelectedIds method from ListViewAdapter Class
                        selected = listviewadapter
                                .getSelectedIds();
                        // Captures all selected ids with a loop
                        for (int i = (selected.size() - 1); i >= 0; i--) {
                            if (selected.valueAt(i)) {
                                String selecteditem = listviewadapter
                                        .getItem(selected.keyAt(i));
                                // Add selected items following the ids
                                listCopyFiles.add(selecteditem);

                            }
                        }

                        fabCancel.setVisibility(View.VISIBLE);
                        fabSend.setVisibility(View.VISIBLE);
                        copy = false;

                        // Close CAB
                        mode.finish();

                        return true;

                    //RENAME SELECTED FILES
                    case R.id.rename:

                        AlertDialog.Builder alertDialog;
                        AlertDialog dialog;

                        alertDialog = new AlertDialog.Builder(MainActivity.this);

                        LayoutInflater inflater = getLayoutInflater();
                        View convertView = inflater.inflate(R.layout.dialog_name_folder, null);

                        final TextView txtFolderName = (TextView) convertView.findViewById(R.id.txtFolderName);
                        txtFolderName.setHint(getStringResources(R.string.hintFile));

                        alertDialog.setView(convertView);
                        /**
                         * Positive Button, it will make tje folder if the name don't exist inside the folder
                         * It will make a TOAST reporting what it will have done
                         */
                        alertDialog.setPositiveButton(getStringResources(R.string.accept),
                                new DialogInterface.OnClickListener() {

                                    public void onClick(DialogInterface dialog, int which) {
                                        //The name folder cannot be empty
                                        SparseBooleanArray selected = listviewadapter
                                                .getSelectedIds();

                                        //IF the size is one we can continue
                                        if(selected.size() == 1)
                                        {
                                            //Get name file
                                            String selecteditem = listviewadapter
                                                    .getItem(selected.keyAt(0));


                                            //Get file extension
                                            String extension = FileUtil.getExtension(selecteditem);
                                            //Get extension putted in the textview
                                            String extensionTXT = FileUtil.getExtension(txtFolderName.getText().toString());

                                            String fileName = txtFolderName.getText().toString();

                                            //IF it has not an extension we put the extension of the file

                                            if(extensionTXT.equalsIgnoreCase("") &&
                                                   ! FolderUtil.isFolder(currentPath + "/" + selecteditem))
                                            {
                                                fileName += "." +extension;
                                            }

                                            //If there are not a file with whte same name we rename the file
                                            if(!FileUtil.fileExists(currentPath + "/" + fileName)){

                                                FileUtil.renameFile(currentPath + "/" + selecteditem,
                                                        currentPath + "/" + fileName);
                                            }
                                            else
                                            {
                                                Toast.makeText(getApplicationContext(), getStringResources(R.string.ErrorFileSameName), Toast.LENGTH_SHORT).show();
                                            }
                                        }
                                        else
                                        {
                                            Toast.makeText(getApplicationContext(), getStringResources(R.string.ErrorRenameFile), Toast.LENGTH_SHORT).show();
                                        }

                                        //new GetNewListFolders().execute();
                                        updateListView();

                                    }
                                });

                        /**
                         * It will make a TOAST that the renaming has been canceled
                         */
                        alertDialog.setNegativeButton(getStringResources(R.string.cancel),
                                new DialogInterface.OnClickListener() {
                                    public void onClick(DialogInterface dialog, int which) {

                                        Toast.makeText(getApplicationContext(), getStringResources(R.string.RenameCancel), Toast.LENGTH_SHORT).show();
                                    }
                                });

                        alertDialog.setCancelable(true);
                        dialog = alertDialog.show();

                        return true;
                    default:

                        return false;
                }

            }

            @Override
            public void onDestroyActionMode(ActionMode mode) {
                listviewadapter.removeSelection();
            }
        });

        /*if(lv.getChildAt(0).isEnabled())
        {
            lv.getChildAt(0).setEnabled(false);
        }

        if(lv.getChildAt(FolderUtil.getNameFolders(mainFolder).size()-1).isEnabled())
        {
            lv.getChildAt(FolderUtil.getNameFolders(mainFolder).size()-1).setEnabled(false);
        }*/

        /*customHandler = new Handler();

        final Runnable r = new Runnable() {
            public void run() {
                updateListView();
                customHandler.postDelayed(this, 1000);
            }
        };

        customHandler.postDelayed(r, 1000);*/

    }


    /**
     * It will dismiss the dialog for avoid the leak
     */
    @Override
    public void onPause(){

        super.onPause();
        if(pdOpenFile != null)
            pdOpenFile.dismiss();
    }


    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            launchPreferences(null);
            return true;
        }

        if(id == R.id.action_guide){
            launchGuide(null);
        }

        return super.onOptionsItemSelected(item);
    }

    /**
     * It will launch preferences
     * @param view For onClick event
     */
    public void launchPreferences(View view)
    {
        Intent i = new Intent(this, PreferenceActivity.class);
        startActivity(i);
    }

    /**
     * It will launch guide
     * @param view For onClick event
     */
    public void launchGuide(View view)
    {
        Intent i = new Intent(this, GuideApplicationActivity.class);
        startActivity(i);
    }

    /**
     * It will launch the MenuOptionsActivity, passing currentFolder and currentPath values
     * @param view For onClick event
     */
    public void launchMenuOptionsActivity(View view)
    {
        Intent i = new Intent(this, MenuOptionsActivity.class);
        i.putExtra("currentFolder", currentFolder);
        i.putExtra("currentPath", currentPath);
        startActivityForResult(i, MENUOPTIONSACTIVITY_NEWFOLDER_REQUESTCODE);
    }

    /**
     * It will refresh the list of files and directories of the current path in a new Thread
     */
    public class GetNewListFolders extends AsyncTask<Void, Void, Void> {

        @Override
        protected void onPreExecute() {
            super.onPreExecute();
            //Do nothing
        }

        @Override
        protected Void doInBackground(Void... params) {

            listNameFolders.clear();
            for(int i = 0; i < FileUtil.getNameFilesAndDirectories(currentPath).size();
                    i++)
            {
                listNameFolders.add(FileUtil.getNameFilesAndDirectories(currentPath).get(i));
            }

            return null;
        }

        @Override
        protected void onPostExecute(Void result) {
            super.onPostExecute(result);

            listviewadapter.notifyDataSetChanged();
            //adapterLV.notifyDataSetChanged();
            //lvFolders.invalidateViews();
            //lvFolders.refreshDrawableState();
        }
    }

    /**
     * On activity for result
     * @param requestCode Request code from the activity from
     * @param resultCode Result code could be OK or CANCELED
     * @param data ??
     */
    @Override protected void onActivityResult (int requestCode,
                                               int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);

        if (requestCode==MENUOPTIONSACTIVITY_NEWFOLDER_REQUESTCODE && resultCode==RESULT_OK && data!=null) {

            updateListView();
            //new GetNewListFolders().execute();
        }

        //TODO CHange the requestCode to a general
        if (requestCode==MENUOPTIONSACTIVITY_NEWFOLDER_REQUESTCODE && resultCode==RESULT_ENCRYPT && data!=null) {

            String filePath = Environment.getExternalStorageDirectory() +
                    "/" + data.getStringExtra("filePath");
            String currenPathFile = data.getStringExtra("currentPath");

            System.out.println("Encrypting..." + filePath);
            System.out.println("Encrypting..." + currenPathFile.replace("file:", ""));


            new EncryptFiles(filePath,  currenPathFile.replace("file:", ""), ENCRYPT_FILE).execute();
           //new GetNewListFolders().execute();
        }

        if (requestCode==MENUOPTIONSACTIVITY_NEWFOLDER_REQUESTCODE && resultCode==RESULT_ENCRYPT_IMAGE && data!=null) {

            String filePath = Environment.getExternalStorageDirectory() +
                    "/" + data.getStringExtra("filePath");
            String currenPathFile = data.getStringExtra("currentPath");

            System.out.println("Encrypting..." + filePath);
            System.out.println("Encrypting..." + currenPathFile.replace("file:", ""));

            new EncryptFiles(filePath,  currenPathFile.replace("file:", ""), ENCRYPT_IMAGE).execute();
            //new GetNewListFolders().execute();
        }
    }

    /**
     * It will go Home
     */
    @Override
    public void onBackPressed() {

        Intent setIntent = new Intent(Intent.ACTION_MAIN);
        setIntent.addCategory(Intent.CATEGORY_HOME);
        setIntent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
        startActivity(setIntent);
    }

    /**
     * It will get the string from the resources Values
     * @param id Id of the resource String
     * @return String String from the id resource
     */
    public String getStringResources(int id) {
        Resources res = getResources();
        return res.getString(id);
    }

    /**
     * It will refresh the list of files and directories of the current path in a new Thread
     */
    public class EncryptFiles extends AsyncTask<Void, Void, Void> {

        String filePath;
        String currenPathFile;
        int typeEncription;
        boolean deleteOriginal;

        public EncryptFiles(String filePath, String currenPathFile, int typeEncription)
        {
            this.filePath = filePath;
            this.currenPathFile = currenPathFile;
            this.typeEncription = typeEncription;
        }

        @Override
        protected void onPreExecute() {
            super.onPreExecute();
            //Do nothing

            SharedPreferences pref = PreferenceManager
                    .getDefaultSharedPreferences(getApplicationContext());
            deleteOriginal = pref.getBoolean("deleteFile", false);

            progressBarGroup.setVisibility(View.VISIBLE);
            tvOperation.setText(getStringResources(R.string.encrypting));
           /* pdOpenFile = ProgressDialog.show(MainActivity.this,"",
                    "Encrypting file...", true,false);*/

        }

        @Override
        protected Void doInBackground(Void... params) {

            //TODO Delete original file

            String key = getKey();
            File inputFile = new File(currenPathFile);
            File encryptedFile = new File(filePath);

            System.out.println("Encrypting file ..." + currenPathFile);
            System.out.println("Encrypting to ..." + filePath);

            try {
                if(typeEncription ==ENCRYPT_IMAGE) {
                    CryptoUtils.encryptImage(key, inputFile, encryptedFile);
                }
                else
                {
                    CryptoUtils.encrypt(key, inputFile, encryptedFile);
                }
                System.out.println("Encrypting finalized...");

                //DELETE ORGINAL FILE
                if(deleteOriginal) {
                    Thread.sleep(100);
                    FileUtil.deleteFile(currenPathFile);
                    System.out.println("Original deleted...");

                }

            } catch (CryptoException e) {
                e.printStackTrace();
                System.out.println("Encrypting error..."+ e.getMessage());
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
            System.out.println("Encrypted");


            return null;
        }

        @Override
        protected void onPostExecute(Void result) {
            super.onPostExecute(result);

            updateListView();

            //check result
            //pdOpenFile.dismiss();
            progressBarGroup.setVisibility(View.GONE);

            //listviewadapter.notifyDataSetChanged();
            //adapterLV.notifyDataSetChanged();
            //lvFolders.invalidateViews();
            //lvFolders.refreshDrawableState();
        }
    }

    /**
     * It will open the file
     */
    public class OpenFiles extends AsyncTask<Void, Void, Void> {

        int type;
        String pathURI;
        Context context;
        boolean succes;

        public OpenFiles(int type, String pathURI, Context context)
        {
            this.type = type;
            this.pathURI = pathURI;
            this.context = context;
            succes = true;
        }

        @Override
        protected void onPreExecute() {
            super.onPreExecute();

            Toast.makeText(context, getStringResources(R.string.decrypting), Toast.LENGTH_SHORT).show();
            pdOpenFile = ProgressDialog.show(MainActivity.this,"",
                    getStringResources(R.string.opening), true,false);

        }

        @Override
        protected Void doInBackground(Void... params) {

            //TODO Delete original file
//            Toast.makeText(context, "Openning", Toast.LENGTH_LONG).show();
            switch(type)
            {
                case VIDEO:
                    IntentUtil.intentVideo(context, pathURI);
                    break;
                case PDF:
                    IntentUtil.intentPDF(context, pathURI);
                    break;
                case IMAGE:
                    IntentUtil.intentImage(context, pathURI);
                    break;
                case AUDIO:
                    IntentUtil.intentAudio(context, pathURI);
                    break;
                case TXT:
                    IntentUtil.intentTXT(context, pathURI);
                    break;
                default:
                    break;

            }

            return null;
        }

        @Override
        protected void onPostExecute(Void result) {
            super.onPostExecute(result);
            //check result
            pdOpenFile.dismiss();
            listviewadapter.notifyDataSetChanged();
        }
    }

    /**
     * It will open the file
     */
    public class OperationFiles extends AsyncTask<Void, Void, Void> {

        boolean succesOperation;

        public OperationFiles()
        {
            succesOperation = true;
        }

        @Override
        protected void onPreExecute() {
            super.onPreExecute();

            progressBarGroup.setVisibility(View.VISIBLE);
            tvOperation.setText(getStringResources(R.string.PastingFiles));

        }

        @Override
        protected Void doInBackground(Void... params) {

            for(int i = 0; i < listCopyFiles.size(); i++) {

                if(!FileUtil.fileExists(currentPath + "/" + listCopyFiles.elementAt(i))) {
                    if (FolderUtil.isFolder(currentPathCopy + "/" + listCopyFiles.elementAt(i))) {
                        if (copy) {
                            FolderUtil.copyFolder(currentPathCopy + "/" + listCopyFiles.elementAt(i),
                                    currentPath + "/" + listCopyFiles.elementAt(i));
                        } else {
                            FolderUtil.moveFolder(currentPathCopy + "/" + listCopyFiles.elementAt(i),
                                    currentPath + "/" + listCopyFiles.elementAt(i));
                        }
                    } else {
                        if (copy) {
                            FileUtil.copyFile(currentPathCopy + "/" + listCopyFiles.elementAt(i),
                                    currentPath + "/" + listCopyFiles.elementAt(i));
                        } else {
                            String mainPath = Environment.getExternalStorageDirectory() +
                                    "/";
                            FileUtil.moveFile(mainPath + currentPathCopy + "/" + listCopyFiles.elementAt(i),
                                    currentPath + "/" + listCopyFiles.elementAt(i));
                        }
                    }
                }
                else
                {
                    succesOperation = false;

                }
            }

            listCopyFiles.clear();


            return null;
        }

        @Override
        protected void onPostExecute(Void result) {
            super.onPostExecute(result);
            //check result

            updateListView();

            if(!succesOperation)
                Toast.makeText(getApplicationContext(),
                        getStringResources(R.string.ErrorFileSameName), Toast.LENGTH_SHORT).show();
            else
                Toast.makeText(getApplicationContext(),
                        getStringResources(R.string.succes), Toast.LENGTH_SHORT).show();


            fabSend.setVisibility(View.GONE);
            fabCancel.setVisibility(View.GONE);

            progressBarGroup.setVisibility(View.GONE);
        }
    }


    /**
     * To comment
     * @return Key Return the key to encrypt
     */
    private String getKey()
    {
        SharedPreferences prefs = getSharedPreferences("Password",
                Context.MODE_PRIVATE);

        String hash = prefs.getString("pass", "?");
        String key = "Makskdkskdkskdks";

        if(hash.length() < 16)
        {

            key = StringUtils.leftPad(hash, 16 - hash.length(), "E");
        }
        else if(hash.length() > 16)
        {
            key = hash.substring(0, 16);

        }
        else
        {
            key = hash;
        }

        return key;
    }


    public void updateListView()
    {
        listNameFolders.clear();
        for(int i = 0; i < FileUtil.getNameFilesAndDirectories(currentPath).size();
            i++)
        {
            listNameFolders.add(FileUtil.getNameFilesAndDirectories(currentPath).get(i));
        }

        listviewadapter.notifyDataSetChanged();
    }


    /*private Runnable updateFiles = new Runnable() {

        public void run() {


            customHandler.postDelayed(this, 0);
        }

    };*/

}
