package upv.pauchorroyanguas.com.encryptorpcy;

import android.app.Activity;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.res.Resources;
import android.database.Cursor;
import android.net.Uri;
import android.os.Build;
import android.os.CountDownTimer;
import android.os.Environment;
import android.os.Handler;
import android.os.SystemClock;
import android.provider.DocumentsContract;
import android.provider.MediaStore;
import android.support.design.widget.FloatingActionButton;
import android.support.v7.app.ActionBarActivity;
import android.os.Bundle;
import android.support.v7.app.AlertDialog;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.ImageButton;
import android.widget.TextView;
import android.widget.Toast;

import org.apache.commons.io.FileUtils;

import java.io.File;
import java.io.IOException;

import upv.pauchorroyanguas.com.encryptorpcy.Utils.FileUtil;
import upv.pauchorroyanguas.com.encryptorpcy.Utils.FolderUtil;
import upv.pauchorroyanguas.com.encryptorpcy.Utils.ImageUtil;
import upv.pauchorroyanguas.com.encryptorpcy.Utils.IntentUtil;
import upv.pauchorroyanguas.com.encryptorpcy.Utils.VideoUtil;
import upv.pauchorroyanguas.com.encryptorpcy.Utils.VoiceNoteUtil;


public class MenuOptionsActivity extends ActionBarActivity {

    private static int RESULT_ENCRYPT = 450;
    private static int RESULT_GALLERY = 451;

    ImageUtil imageUtil;
    VideoUtil videoutil;

    VoiceNoteUtil voiceRecorder;

    String currentpathFileVoiceRecorder;

    //Views

    FloatingActionButton btnRecord;
    FloatingActionButton btnFolder;
    FloatingActionButton btnPhoto;
    FloatingActionButton btnVideo;
    FloatingActionButton btnCall;
    FloatingActionButton btnFindFile;


    private static final String LOG_TAG = "TAG_MENU_OPTIONS_ACT";

    final Activity activity = this;

    //Bundle fields
    String currentFolder;
    String currentPath;

    //Constants Folders
    private static String mainFolder = ".EncryptorPCY";

    //CONST NUM
    private static final int RESULT_CAMERA = 1;
    private static final int CAPTURE_VIDEO_ACTIVITY_REQUEST_CODE = 2;

    //Timer record voice note
    private long startTime = 0L;

    private Handler customHandler = new Handler();

    long timeInMilliseconds = 0L;
    long timeSwapBuff = 0L;
    long updatedTime = 0L;
    TextView tvChronometer;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_menu_options);

        imageUtil = new ImageUtil(activity, getApplicationContext());
        videoutil = new VideoUtil(activity, getApplicationContext());

        //Bundle
        Bundle extras = getIntent().getExtras();
        currentFolder = extras.getString("currentFolder");
        currentPath = extras.getString("currentPath");

        voiceRecorder = new VoiceNoteUtil(
                "/voice_" + (System.currentTimeMillis() / 1000));

        btnRecord = (FloatingActionButton) findViewById(R.id.btnRecordVoice);
        btnFolder = (FloatingActionButton) findViewById(R.id.btnFolder);
        btnPhoto = (FloatingActionButton) findViewById(R.id.btnPhoto);
        btnVideo = (FloatingActionButton) findViewById(R.id.btnVideo);
        btnFindFile = (FloatingActionButton) findViewById(R.id.btnFindFile);
        btnCall = (FloatingActionButton) findViewById(R.id.btnCall);


        btnCall.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Toast.makeText(getApplicationContext(),
                        getStringResources(R.string.NotImplementedYet) + "\n"
                                + getStringResources(R.string.ForFinalProject),
                        Toast.LENGTH_LONG).show();
            }
        });

        /**
         * Button find file
         */
        btnFindFile.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent;

                if (Build.VERSION.SDK_INT < 19){
                    intent = new Intent();
                    intent.setAction(Intent.ACTION_GET_CONTENT);
                    intent.setType("*/*");
                    startActivityForResult(intent, RESULT_GALLERY);
                } else {
                    intent = new Intent(Intent.ACTION_OPEN_DOCUMENT);
                    intent.addCategory(Intent.CATEGORY_OPENABLE);
                    intent.setType("*/*");
                    startActivityForResult(intent, RESULT_GALLERY);
                }
            }
        });

        /**
         * Button folder
         */
        btnFolder.setOnClickListener(new View.OnClickListener() {
            AlertDialog.Builder alertDialog;
            AlertDialog dialog;

            @Override
            public void onClick(View v) {

                alertDialog = new AlertDialog.Builder(MenuOptionsActivity.this);

                LayoutInflater inflater = getLayoutInflater();
                View convertView = inflater.inflate(R.layout.dialog_name_folder, null);

                final TextView txtFolderName = (TextView) convertView.findViewById(R.id.txtFolderName);


                alertDialog.setView(convertView);
                /**
                 * Positive Button, it will make tje folder if the name don't exist inside the folder
                 * It will make a TOAST reporting what it will have done
                 */
                alertDialog.setPositiveButton(getStringResources(R.string.Accept),
                        new DialogInterface.OnClickListener() {
                            public void onClick(DialogInterface dialog, int which) {
                                //The name folder cannot be empty
                                if ("".equals(txtFolderName.getText().toString())) {
                                    Toast.makeText(getApplicationContext(),
                                            getStringResources(R.string.NameNoEmpty),
                                            Toast.LENGTH_SHORT).show();
                                } else {

                                    //TODO Check if the name exists

                                    if (FolderUtil.createFolder(currentPath, txtFolderName.getText().toString())) {

                                        Toast.makeText(getApplicationContext(), getStringResources(R.string.FolderCreated) +
                                                txtFolderName.getText().toString(), Toast.LENGTH_SHORT).show();


                                    } else {
                                        Toast.makeText(getApplicationContext(), getStringResources(R.string.FileNoCreated), Toast.LENGTH_SHORT).show();
                                    }

                                    finalizarActivityOK();

                                }

                            }
                        });
                alertDialog.setNegativeButton(getStringResources(R.string.Cancel),
                        new DialogInterface.OnClickListener() {
                            public void onClick(DialogInterface dialog, int which) {

                                Toast.makeText(getApplicationContext(), getStringResources(R.string.Discard), Toast.LENGTH_SHORT).show();
                                finalizarActivityOK();

                            }
                        });

                alertDialog.setCancelable(true);
                dialog = alertDialog.show();

            }
        });

        /**
         * Button record voice note
         */
        btnRecord.setOnClickListener(
                new View.OnClickListener() {

                AlertDialog.Builder alertDialog;
                AlertDialog dialog;

            @Override
            public void onClick(View v) {

                alertDialog = new AlertDialog.Builder(MenuOptionsActivity.this);

                LayoutInflater inflater = getLayoutInflater();
                View convertView = inflater.inflate(R.layout.dialog_name_voicenote, null);

                final ImageButton btnRecorder = (ImageButton) convertView.findViewById(R.id.btnRecorder);
                tvChronometer = (TextView) convertView.findViewById(R.id.chronometer);
                //btnRecorder.setEnabled(false);

                alertDialog.setView(convertView);

                btnRecorder.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {

                        //Voice Recorider
                        voiceRecorder.onRecord(voiceRecorder.ismStartRecording());
                        if (voiceRecorder.ismStartRecording()) {
                            btnRecorder.setImageResource(R.drawable.ic_stop_black_24dp);

                            //Disable buttons while is recording
                            dialog.getButton(AlertDialog.BUTTON_POSITIVE).setEnabled(false);
                            dialog.getButton(AlertDialog.BUTTON_NEGATIVE).setEnabled(false);

                            startTime = SystemClock.uptimeMillis();
                            customHandler.postDelayed(updateTimerThread, 0);


                        } else {
                            btnRecorder.setImageResource(R.drawable.ic_mic_black_24dp);

                            //Enable Positive Button SAVE when it has finished the recording
                            dialog.getButton(AlertDialog.BUTTON_POSITIVE).setEnabled(true);
                            dialog.getButton(AlertDialog.BUTTON_NEGATIVE).setEnabled(false);
                            btnRecorder.setEnabled(false);

                            timeSwapBuff += timeInMilliseconds;
                            customHandler.removeCallbacks(updateTimerThread);
                        }
                        voiceRecorder.setmStartRecording(!voiceRecorder.ismStartRecording());

                        currentpathFileVoiceRecorder = voiceRecorder.getmFileName();

                    }
                });

                /**
                 * It will save the file, changing the name of the file to the choosed one
                 */
                alertDialog.setPositiveButton(getStringResources(R.string.Save),
                        new DialogInterface.OnClickListener() {
                            public void onClick(DialogInterface dialog, int which) {
                                //finalizarActivityOK();
                                String nameVoice =  currentPath + "/" + "audio_" +
                                        (System.currentTimeMillis() / 1000) + ".3gp";
                                finalizeActivityEncrypt(currentpathFileVoiceRecorder, nameVoice);

                            }
                        });
                /**
                 * It will cancel, removing the file recorded
                 */
                alertDialog.setNegativeButton(getStringResources(R.string.cancel),
                        new DialogInterface.OnClickListener() {
                            public void onClick(DialogInterface dialog, int which) {
                                //TODO Delete the file
                                Toast.makeText(getApplicationContext(), getStringResources(R.string.Discard), Toast.LENGTH_SHORT).show();
                                finalizarActivityOK();
                            }
                        });


                alertDialog.setCancelable(true);
                dialog = alertDialog.show();

                dialog.getButton(AlertDialog.BUTTON_POSITIVE).setEnabled(false);

            }
        });

        /**
         * Buton create video
         */
        btnVideo.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                videoutil.videoCaptureIntent();

            }
        });

        /**
         * Button Capture Photo
         */
        btnPhoto.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                //IntentUtil.intentImageCapture(activity, currentPath);
                //i.imageCaptureIntent(currentPath, "img_" + (System.currentTimeMillis() / 1000) + ".jpg");
                imageUtil.dispatchTakePictureIntent(activity, currentPath);
            }
        });

    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_menu_options, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }


    /**
     * It will finalize the activity for result, with RESULT_OK
     */
    private void finalizarActivityOK() {

        Intent intent = new Intent();
        setResult(Activity.RESULT_OK, intent);
        finish();
    }

    /**
     * It will go to OnActivityResult of RESULT_ENCRYPT
     * @param currentPath
     * @param filePath
     */
    private void finalizeActivityEncrypt(String currentPath, String filePath)
    {
        Intent intent = new Intent();
        intent.putExtra("filePath", filePath);
        intent.putExtra("currentPath", currentPath);
        setResult(RESULT_ENCRYPT, intent);
        finish();
    }

    /**
     * It will go to OnActivityResult of RESULT_ENCRYPT_IMAGE
     * @param currentPath
     * @param filePath
     */
    private void finalizeActivityEncryptImage(String currentPath, String filePath)
    {
        Intent intent = new Intent();
        intent.putExtra("filePath", filePath);
        intent.putExtra("currentPath", currentPath);
        setResult(MainActivity.RESULT_ENCRYPT_IMAGE, intent);
        finish();
    }

    /**
     * On activity for result
     * @param requestCode Request code from the activity from
     * @param resultCode Result code could be OK or CANCELED
     * @param data ??
     */
    @Override protected void onActivityResult (int requestCode,
                                               int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);

        if (requestCode==RESULT_CAMERA && data!=null && resultCode == Activity.RESULT_OK) {

            String namePhoto =   currentPath + "/" + "img_" + (System.currentTimeMillis() / 1000) + ".jpg";

            Toast.makeText(getApplicationContext(), getStringResources(R.string.PhotoCreated),
                    Toast.LENGTH_LONG).show();
            //FileUtil.moveFile(imageUtil.getmCurrentPhotoPath(), namePhoto);

            finalizeActivityEncryptImage(imageUtil.getmCurrentPhotoPath(), namePhoto);
            //finalizarActivityOK();
        }

        if (requestCode == CAPTURE_VIDEO_ACTIVITY_REQUEST_CODE) {
            if (resultCode == Activity.RESULT_OK) {

                // Video captured and saved to fileUri specified in the Intent
                Toast.makeText(this, getStringResources(R.string.VideoSaved), Toast.LENGTH_LONG).show();

                String nameVideo =  currentPath + "/" + "video_" + (System.currentTimeMillis() / 1000) + ".mp4";

                //FileUtil.moveFile(videoutil.getmCurrentVideoPath(), currentPath + "/" +
                //       nameVideo);


                Log.e(LOG_TAG, videoutil.getmCurrentVideoPath() + ", " + currentPath + "/" +
                        "video_" + (System.currentTimeMillis() / 1000) + ".mp4");

                //finalizarActivityOK();

                finalizeActivityEncrypt(videoutil.getmCurrentVideoPath(), nameVideo);
            }
        }

        if(requestCode == RESULT_GALLERY && resultCode ==  Activity.RESULT_OK)
        {
            Uri uri = data.getData();


            String filePath = FileUtil.getPath(getApplicationContext(), uri);

            if(filePath != null) {
                String[] partsFile = filePath.split("/");
                String nameFile = currentPath + "/" + partsFile[partsFile.length - 1];

                if(FileUtil.getExtension(filePath).equalsIgnoreCase("jpg") ||
                        FileUtil.getExtension(filePath).equalsIgnoreCase("png") ||
                        FileUtil.getExtension(filePath).equalsIgnoreCase("gif")) {
                    finalizeActivityEncryptImage(filePath, nameFile);
                }
                else
                {
                    finalizeActivityEncrypt(filePath, nameFile);
                }
            }
            else {
                Toast.makeText(this, "Sorry, the file cannot be found", Toast.LENGTH_LONG).show();

            }
        }
    }

    /**
     * It will get the string from the resources Values
     * @param id Id of the resource String
     * @return String String from the id resource
     */
    public String getStringResources(int id)
    {
        Resources res = getResources();
        return res.getString(id);
    }

    private Runnable updateTimerThread = new Runnable() {

        public void run() {

            timeInMilliseconds = SystemClock.uptimeMillis() - startTime;

            updatedTime = timeSwapBuff + timeInMilliseconds;

            int secs = (int) (updatedTime / 1000);
            int mins = secs / 60;
            secs = secs % 60;
            int milliseconds = (int) (updatedTime % 1000);
            tvChronometer.setText("" + mins + ":"
                    + String.format("%02d", secs) + ":"
                    + String.format("%03d", milliseconds));
            customHandler.postDelayed(this, 0);
        }

    };



}
