package upv.pauchorroyanguas.com.encryptorpcy;

import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.res.Resources;
import android.support.v7.app.ActionBarActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Toast;

import upv.pauchorroyanguas.com.encryptorpcy.Utils.FileUtil;

/**
 * Author: Pau Chorro
 * Date: 01/11/15
 *
 * Splash Activity
 */
public class SplashActivity extends ActionBarActivity {


    private static final String LOG_TAG = "TAG_SPLASH_ACT";

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_splash);

        //Launch the login activity in case of the ExternalStorage is Writable and Readeable
        if(FileUtil.isExternalStorageReadable() && FileUtil.isExternalStorageWritable()) {
            SharedPreferences prefs =
                    getSharedPreferences("Password", Context.MODE_PRIVATE);

            String pass = prefs.getString("pass", "?");

            Log.e(LOG_TAG, "Pass: " + pass);

            if(!pass.equals("?"))
                launchLogin(null);
            else
                launchCreatePass(null);

        }
        else
        {
            Toast.makeText(getApplicationContext(), getStringResources(R.string.ErrorMounted),
                    Toast.LENGTH_LONG);
        }
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_splash, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    /**
     * Launch Login Activity
     * @param view Prepared for method OnClick
     */
    public void launchLogin(View view)
    {
        Intent i = new Intent(this, LoginActivity.class);
        startActivity(i);
    }

    /**
     * Launch CreatePass Activity
     * @param view Prepared for method OnClick
     */
    public void launchCreatePass(View view)
    {
        Intent i = new Intent(this, CreatePasswordActivity.class);
        startActivity(i);
    }

    /**
     * It will get the string from the resources Values
     * @param id Id of the resource String
     * @return String String from the id resource
     */
    public String getStringResources(int id)
    {
        Resources res = getResources();
        return res.getString(id);
    }
}
