package upv.pauchorroyanguas.com.encryptorpcy.Utils;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.net.Uri;
import android.os.Environment;
import android.provider.MediaStore;
import android.util.Log;

import java.io.File;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * Author: Pau Chorro
 * Date: 01/11/15
 *
 * ImageUtil Class
 */
public class ImageUtil {

    //Const
    private static final int CAPTURE_IMAGE_ACTIVITY_REQUEST_CODE = 100;
    private static final String LOG_TAG = "TAG_IMAGE_UTIL";
    private static String mainPath = Environment.getExternalStorageDirectory() +
            "/";

    //Fields
    Context context;
    Activity activity;

    /**
     * Constructor of ImageUtil
     * @param activity Activity - Instance of the Activity where it is created the object to call
     *                 activity methods
     * @param context Context - Context of the activity
     */
    public ImageUtil(Activity activity, Context context)
    {
        this.context = context;
        this.activity = activity;
    }

    String mCurrentPhotoPath;

    private File createImageFile() throws IOException {
        // Create an image file name
        //String timeStamp = new SimpleDateFormat("yyyyMMdd_HHmmss").format(new Date());
        String imageFileName = "img_default" ;
        File storageDir = Environment.getExternalStoragePublicDirectory(Environment.DIRECTORY_PICTURES);

        if(!storageDir.exists())
            storageDir.mkdir();

        File image = File.createTempFile(
                imageFileName,  /* prefix */
                ".jpg",         /* suffix */
                storageDir      /* directory */
        );

        // Save a file: path for use with ACTION_VIEW intents
        mCurrentPhotoPath = "file:" + image.getAbsolutePath();
        Log.e(LOG_TAG, "file:" + image.getAbsolutePath());
        return image;
    }

    static final int REQUEST_TAKE_PHOTO = 1;

    public void dispatchTakePictureIntent(Activity activity, String currentPath) {
        Log.e(LOG_TAG, "dispatchTakePictureIntent: " +"1");
        Intent takePictureIntent = new Intent(MediaStore.ACTION_IMAGE_CAPTURE);
        // Ensure that there's a camera activity to handle the intent
        if (takePictureIntent.resolveActivity(activity.getPackageManager()) != null) {
            // Create the File where the photo should go
            Log.e(LOG_TAG, "dispatchTakePictureIntent: " +"2");
            File photoFile = null;
            try {
                Log.e(LOG_TAG, mainPath + currentPath);
                photoFile = createImageFile();
                Log.e(LOG_TAG, "dispatchTakePictureIntent: " +"3 - Image created");
            } catch (IOException ex) {
                // Error occurred while creating the File

            }
            // Continue only if the File was successfully created
            if (photoFile != null) {
                takePictureIntent.putExtra(MediaStore.EXTRA_OUTPUT,
                        Uri.fromFile(photoFile));
                Log.e(LOG_TAG, "takepicture: " + "4");
                activity.startActivityForResult(takePictureIntent, REQUEST_TAKE_PHOTO);

            }
        }
    }

    public String getmCurrentPhotoPath() {
        return mCurrentPhotoPath;
    }

    public void setmCurrentPhotoPath(String mCurrentPhotoPath) {
        this.mCurrentPhotoPath = mCurrentPhotoPath;
    }
}
