package upv.pauchorroyanguas.com.encryptorpcy.Utils;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.net.Uri;
import android.os.Build;
import android.os.Environment;
import android.provider.MediaStore;
import android.util.Log;
import android.widget.Toast;

import org.apache.commons.lang3.StringUtils;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;

import upv.pauchorroyanguas.com.encryptorpcy.Exception.CryptoException;

/**
 * Author: Pau Chorro
 * Date: 09/11/15
 *
 * IntentUtil Class TODO Impl
 */
public class IntentUtil {

    /**
     * Launch default application audio
     * @param context Application context from activity
     * @param path Path of the file to launch (Format: path/file.extension)
     */
    public static void intentAudio(Context context, String path)
    {
        //Toast.makeText(context, "Opening Audio....", Toast.LENGTH_SHORT).show();

        Intent intent = new Intent();
        intent.setAction(android.content.Intent.ACTION_VIEW);
        File file = new File(path);

        //DecryptFile
        if(FileUtil.hasExternalStoragePrivateFile(context, "document.key"));
        FileUtil.deleteExternalStoragePrivateFile(context, "document.key");

        File decryptedFile = FileUtil.createExternalStoragePrivateFile(context, "document.key");

        String key = getKey(context);

        try {
            CryptoUtils.decrypt(key, file, decryptedFile);
        } catch (CryptoException e) {
            e.printStackTrace();
        }

        intent.setDataAndType(Uri.fromFile(decryptedFile), "audio/*");
        intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
        context.startActivity(intent);
    }

    /**
     * Launch default application for text/plain
     * @param context Application context from activity
     * @param path Path of the file to launch (Format: path/file.extension)
     */
    public static void intentTXT(Context context, String path)
    {
        //Toast.makeText(context, "Opening TXT....", Toast.LENGTH_SHORT).show();

        File file = new File(path);

        //DecryptFile
        /*if(FileUtil.hasExternalStoragePrivateFile(context, "document.key"));
        FileUtil.deleteExternalStoragePrivateFile(context, "document.key");

        File decryptedFile = FileUtil.createExternalStoragePrivateFile(context, "document.key");

        String key = getKey(context);
        try {
            CryptoUtils.decrypt(key, file, decryptedFile);
        } catch (CryptoException e) {
            e.printStackTrace();
        }*/

        Intent intent = new Intent();
        intent.setAction(android.content.Intent.ACTION_VIEW);
        intent.setDataAndType(Uri.fromFile(file), "text/plain");
        intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
        context.startActivity(intent);
    }

    /**
     * Launch default application for pdf
     * @param context Application context from activity
     * @param path Path of the file to launch (Format: path/file.extension)
     */
    public static void intentPDF(Context context, String path)
    {
        //Toast.makeText(context, "Opening PDF....", Toast.LENGTH_SHORT).show();

        File file = new File(path);

        //DecryptFile
        if(FileUtil.hasExternalStoragePrivateFile(context, "document.key"));
        FileUtil.deleteExternalStoragePrivateFile(context, "document.key");

        File decryptedFile = FileUtil.createExternalStoragePrivateFile(context, "document.key");

        String key = getKey(context);
        try {
            CryptoUtils.decrypt(key, file, decryptedFile);
        } catch (CryptoException e) {
            e.printStackTrace();
        }

        Intent intent = new Intent();
        intent.setAction(android.content.Intent.ACTION_VIEW);
        intent.setDataAndType(Uri.fromFile(decryptedFile), "application/pdf");
        intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
        context.startActivity(intent);
    }

    /**
     * Launch default application for images
     * @param context Application context from activity
     * @param path Path of the file to launch (Format: path/file.extension)
     */
    public static void intentImage(Context context, String path)
    {
        //Toast.makeText(context, "Openning image....", Toast.LENGTH_SHORT).show();

        File file = new File(path);

        //DecryptFile
        if(FileUtil.hasExternalStoragePrivateFile(context, "document.key"));
            FileUtil.deleteExternalStoragePrivateFile(context, "document.key");

        File decryptedFile = FileUtil.createExternalStoragePrivateFile(context, "document.key");

        String key = getKey(context);
        try {
            CryptoUtils.decryptImage(key, file, decryptedFile);
        } catch (CryptoException e) {
            e.printStackTrace();
        }

        Intent intent = new Intent();
        intent.setAction(android.content.Intent.ACTION_VIEW);
        intent.setDataAndType(Uri.fromFile(decryptedFile), "image/*");
        intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
        context.startActivity(intent);

    }

    /**
     * Launch default application for videos
     * @param context Application context from activity
     * @param path Path of the file to launch (Format: path/file.extension)
     */
    public static void intentVideo(Context context, String path)  {
        //Toast.makeText(context, "Openning video....", Toast.LENGTH_SHORT).show();

        File file = new File(path);

        //DecryptFile
        if (FileUtil.hasExternalStoragePrivateFile(context, "document.key"));
            FileUtil.deleteExternalStoragePrivateFile(context, "document.key");

        File decryptedFile = FileUtil.createExternalStoragePrivateFile(context, "document.key");

        String key = getKey(context);
        try {
            CryptoUtils.decrypt(key, file, decryptedFile);
        } catch (CryptoException e) {
            e.printStackTrace();
        }

        Intent intent = new Intent();
        intent.setAction(android.content.Intent.ACTION_VIEW);
        intent.setDataAndType(Uri.fromFile(decryptedFile), "video/*");
        intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
        context.startActivity(intent);

    }

    /**
     *
     * @param activity
     * @param path
     */
    public static void intentImageCapture(Activity activity, String path)
    {
        Log.e("LOG_INTENTUTIL", path + "/" + "img_" + (System.currentTimeMillis() / 1000) + ".jpg");

        File file = new File(path + "/" + "img_" + (System.currentTimeMillis() / 1000) + ".jpg");

        Intent intent = new Intent("android.media.action.IMAGE_CAPTURE");

        Uri uriFoto = Uri.fromFile(file);
        intent.putExtra(MediaStore.EXTRA_OUTPUT, uriFoto);
        intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);

        activity.startActivityForResult(intent, 1);
    }


    public static void intentGaleria(Activity activity, String path)
    {
        Intent intent;

        if (Build.VERSION.SDK_INT < 19){
            intent = new Intent();
            intent.setAction(Intent.ACTION_GET_CONTENT);
            intent.setType("image/*");
            activity.startActivityForResult(intent, 0);
        } else {
            intent = new Intent(Intent.ACTION_OPEN_DOCUMENT);
            intent.addCategory(Intent.CATEGORY_OPENABLE);
            intent.setType("image/*");
            activity.startActivityForResult(intent, 0);
        }
    }
    private static String getKey(Context context)
    {
        SharedPreferences prefs = context.getSharedPreferences("Password",
                Context.MODE_PRIVATE);

        String hash = prefs.getString("pass", "?");
        String key = "Makskdkskdkskdks";

        if(hash.length() < 16)
        {

            key = StringUtils.leftPad(hash, 16 - hash.length(), "E");
        }
        else if(hash.length() > 16)
        {
            key = hash.substring(0, 16);
        }
        else
        {
            key = hash;
        }

        return key;
    }


}
