package upv.pauchorroyanguas.com.encryptorpcy.Utils;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.net.Uri;
import android.os.Environment;
import android.provider.MediaStore;
import android.util.Log;

import java.io.File;
import java.io.IOException;

/**
 * Author: Pau Chorro
 * Date: 01/11/15
 *
 * VideoUtil Class
 */
public class VideoUtil {

    //Const
    private static final int CAPTURE_VIDEO_ACTIVITY_REQUEST_CODE = 2;
    private static final String LOG_TAG = "TAG_VIDEO_UTIL";
    private static String mainPath = Environment.getExternalStorageDirectory() +
            "/";


    static final int REQUEST_TAKE_PHOTO = 2;

    //Fields
    Context context;
    Activity activity;

    /**
     * Constructor of videoUtil
     * @param activity Activity - Instance of the Activity where it is created the object to call
     *                 activity methods
     * @param context Context - Context of the activity
     */
    public VideoUtil(Activity activity, Context context)
    {
        this.context = context;
        this.activity = activity;
    }

    /**
     *  Capture a video using a camera Intent
     */
    public void videoCaptureIntent()  {

        File video = null;
        try {
            video = createVideoFile();
        }
        catch(Exception e)
        {
            Log.e(LOG_TAG, e.getMessage());
        }

        //create new Intent
        Intent intent = new Intent(MediaStore.ACTION_VIDEO_CAPTURE);

        //fileUri = getOutputMediaFileUri(MEDIA_TYPE_VIDEO);  // create a file to save the video
        intent.putExtra(MediaStore.EXTRA_OUTPUT,  Uri.fromFile(video));  // set the image file name

        //intent.putExtra(MediaStore.EXTRA_VIDEO_QUALITY, 1); // set the video image quality to high

        Log.e(LOG_TAG, video.getAbsolutePath());

        // start the Video Capture Intent
        activity.startActivityForResult(intent, CAPTURE_VIDEO_ACTIVITY_REQUEST_CODE);
    }

    String mCurrentVideoPath;

    /**
     * It willc reate the file video in the Directory movie
     * @return File video
     * @throws IOException
     */
    private File createVideoFile() throws IOException {
        // Create an image file name
        //String timeStamp = new SimpleDateFormat("yyyyMMdd_HHmmss").format(new Date());
        String imageFileName = "video_default" ;
        File storageDir = Environment.getExternalStoragePublicDirectory(Environment.DIRECTORY_MOVIES);

        if(!storageDir.exists())
            storageDir.mkdir();

        File video = File.createTempFile(
                imageFileName,  /* prefix */
                ".mp4",         /* suffix */
                storageDir      /* directory */
        );

        // Save a file: path for use with ACTION_VIEW intents
        mCurrentVideoPath = "file:" + video.getAbsolutePath();
        Log.e(LOG_TAG, "file:" + video.getAbsolutePath());
        return video;
    }

    /**
     * Get the path of the video when it is saved
     * @return
     */
    public String getmCurrentVideoPath() {
        return mCurrentVideoPath;
    }
}
