package upv.pauchorroyanguas.com.encryptorpcy.adapter;

import android.app.Activity;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;
import java.util.Vector;
import upv.pauchorroyanguas.com.encryptorpcy.Utils.FileUtil;
import upv.pauchorroyanguas.com.encryptorpcy.R;

/**
 *  Author: Pau Chorro
 *  Date: 07/11/15
 *  Class: Adapter for select the folder where the file it will be saved
 */
public class ExplorerFoldersAdapter extends BaseAdapter {

    private final Activity activity;
    private final Vector<String> list;

    /**
     * Constructor of the adapter, it will save the list of strings and the activity
     * @param activity Activity where is passed the
     * @param list
     */
    public ExplorerFoldersAdapter(Activity activity, Vector<String> list)
    {
        super();
        this.activity = activity;
        this.list = list;

    }

    /**
     * View of the element list. There it will be assigned the name of the folder and path
     * @param position
     * @param convertView
     * @param parent
     * @return
     */
    @Override
    public View getView(int position, View convertView, ViewGroup parent) {

        LayoutInflater inflater = activity.getLayoutInflater();
        View v = inflater.inflate(R.layout.adapter_listview_folders, null, true);

        String path = list.elementAt(position);
        String folder  = list.elementAt(position);

        Log.e("LOG_EXPLORERFODLER_ADA", list.elementAt(position));

        TextView txtFolderName = (TextView) v.findViewById(R.id.txtFolderName);
        TextView txtPathFolder = (TextView) v.findViewById(R.id.txtPathFolder);

        if(list.elementAt(position).contains("/"))
        {
            folder = path.substring(path.lastIndexOf("/") +1,
                    path.length()) ;
        }

        txtFolderName.setText(folder);
        txtPathFolder.setText(path);
        ImageView ivFolder = (ImageView) v.findViewById(R.id.icono);

        //Image arrow to go back
        if(position == 0)
        {
            ivFolder.setImageResource(R.drawable.ic_keyboard_backspace_black_24dp);
        }
        /*else if(position == list.size()-1)
        {
            ivFolder.setImageResource(R.drawable.ic_more_horiz_black_24dp);
            txtFolderName.setText("...");
        }*/
        else
        {

            String extension = FileUtil.getExtension(list.get(position));
            if ("txt".equalsIgnoreCase(extension)) {
                ivFolder.setImageResource(R.drawable.ic_description_black_24dp);
            }
            else
            {
                if("".equalsIgnoreCase(extension))
                {
                    ivFolder.setImageResource(R.drawable.ic_folder_black_24dp);
                }
                else if("pdf".equalsIgnoreCase(extension))
                {
                    ivFolder.setImageResource(R.drawable.ic_picture_as_pdf_black_24dp);
                }
                else if("gif".equalsIgnoreCase(extension))
                {
                    ivFolder.setImageResource(R.drawable.ic_gif_black_24dp);
                }
                else if("mp4".equalsIgnoreCase(extension) || "flv".equalsIgnoreCase(extension) ||
                        "avi".equalsIgnoreCase(extension) || "mpg".equalsIgnoreCase(extension) ||
                        "mkv".equalsIgnoreCase(extension))
                {
                    ivFolder.setImageResource(R.drawable.ic_movie_creation_black_24dp);
                }
                else if("jpg".equalsIgnoreCase(extension) || "png".equalsIgnoreCase(extension) ||
                        "jpeg".equalsIgnoreCase(extension))
                {
                    ivFolder.setImageResource(R.drawable.ic_photo_black_24dp);
                }
                else {
                    ivFolder.setImageResource(R.drawable.ic_insert_drive_file_black_24dp);
                }
            }
        }

        return v;
    }

    @Override
    public int getCount() {
        return list.size();
    }

    @Override
    public Object getItem(int position) {
        return list.elementAt(position);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }



}
