package upv.pauchorroyanguas.com.encryptorpcy.adapter;

import android.app.Activity;
import android.content.Context;
import android.os.Environment;
import android.util.Log;
import android.util.SparseBooleanArray;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import java.util.List;

import upv.pauchorroyanguas.com.encryptorpcy.R;
import upv.pauchorroyanguas.com.encryptorpcy.Utils.FileUtil;

/**
 *  Author: Pau Chorro
 *  Date: 09/11/15
 *  Class: Adapter for select the folder where the file it will be saved
 *  TODO To impl
 */
public class ExplorerFoldersAdapterArray extends ArrayAdapter<String> {


    // Declare Variables
    Context context;
    List<String> list;
    private SparseBooleanArray mSelectedItemsIds;
    Activity activity;

    private static String mainPath = Environment.getExternalStorageDirectory() +
            "/";


    public ExplorerFoldersAdapterArray(Context context, int resource,  List<String> list,
                                       Activity activity) {
        super(context, resource, list);

        mSelectedItemsIds = new SparseBooleanArray();
        this.context = context;
        this.list = list;
        this.activity = activity;

    }

    /**
     * View of the element list. There it will be assigned the name of the folder and path
     * @param position
     * @param convertView
     * @param parent
     * @return
     */
    @Override
    public View getView(int position, View convertView, ViewGroup parent) {

        LayoutInflater inflater = activity.getLayoutInflater();
        View v = inflater.inflate(R.layout.adapter_listview_folders, null, true);

            String path = list.get(position);
            String folder  = list.get(position);

            Log.e("LOG_EXPLORERFODLER_ADA", list.get(position));

            TextView txtFolderName = (TextView) v.findViewById(R.id.txtFolderName);
            TextView txtPathFolder = (TextView) v.findViewById(R.id.txtPathFolder);

            if(list.get(position).contains("/"))
            {
                folder = path.substring(path.lastIndexOf("/") +1,
                        path.length()) ;
            }

            txtFolderName.setText(folder);
            txtPathFolder.setText(path);
            ImageView ivFolder = (ImageView) v.findViewById(R.id.icono);

            //Image arrow to go back
            if(position == 0)
            {
                ivFolder.setImageResource(R.drawable.ic_keyboard_backspace_black_24dp);
            }
            /*else if(position == list.size()-1)
            {
                ivFolder.setImageResource(R.drawable.ic_more_horiz_black_24dp);
                txtFolderName.setText("...");
            }*/
            else {

                String extension = FileUtil.getExtension(list.get(position));
                if ("txt".equalsIgnoreCase(extension)) {
                    ivFolder.setImageResource(R.drawable.ic_description_black_24dp);
                } else {
                    if ("".equalsIgnoreCase(extension)) {
                        ivFolder.setImageResource(R.drawable.ic_folder_black_24dp);
                    } else if ("pdf".equalsIgnoreCase(extension)) {
                        ivFolder.setImageResource(R.drawable.ic_picture_as_pdf_black_24dp);
                    } else if ("gif".equalsIgnoreCase(extension)) {
                        ivFolder.setImageResource(R.drawable.ic_gif_black_24dp);
                    } else if ("mp4".equalsIgnoreCase(extension) || "flv".equalsIgnoreCase(extension) ||
                            "avi".equalsIgnoreCase(extension) || "mpg".equalsIgnoreCase(extension) ||
                            "mkv".equalsIgnoreCase(extension)) {
                        ivFolder.setImageResource(R.drawable.ic_movie_creation_black_24dp);
                    } else if ("jpg".equalsIgnoreCase(extension) || "png".equalsIgnoreCase(extension) ||
                            "jpeg".equalsIgnoreCase(extension)) {
                        ivFolder.setImageResource(R.drawable.ic_photo_black_24dp);

                    }else if("3gp".equalsIgnoreCase(extension)){
                        ivFolder.setImageResource(R.drawable.ic_mic_black_24dp);
                    }
                    else if("mp3".equalsIgnoreCase(extension))
                    {
                        ivFolder.setImageResource(R.drawable.ic_music_note_black_24dp);
                    }
                    else {
                        ivFolder.setImageResource(R.drawable.ic_insert_drive_file_black_24dp);
                    }
                }
            }


            //If the map contains the position, it will be selected
            if(mSelectedItemsIds.get(position) && position != 0)
            {
                v.setBackgroundResource(R.color.lightBlue);
            }



        return v;
    }

    /**
     * It will delete the file from the list and de sd card
     * Then it will notify the canges to the listview
     * @param object Object to delete
     */
    @Override
    public void remove(String object) {
        Log.e("Adapter", object + ", " + list.size());
        list.remove(object);
        String path = "";

        if(!list.isEmpty()) {
            path = mainPath + list.get(0) + "/" + object;
        }

        FileUtil.deleteFile(path);

        notifyDataSetChanged();
    }

    /**
     * It will get the list of files
     * @return
     */
    public List<String> getList()
    {
        return list;
    }

    /**
     * It will select the views, except the first position
     * @param position (int) It will select all the views
     */
    public void toggleSelection(int position) {
        if(position != 0)
            selectView(position, !mSelectedItemsIds.get(position));
    }

    /**
     * It will remove the selection
     */
    public void removeSelection() {
        mSelectedItemsIds = new SparseBooleanArray();
        notifyDataSetChanged();
    }

    /**
     *
     * @param position (int) Position of the listview
     * @param value (boolean) If it is selected or not
     */
    public void selectView(int position, boolean value) {

        if(position !=0) {
            if (value)
                mSelectedItemsIds.put(position, value);
            else
                mSelectedItemsIds.delete(position);

            notifyDataSetChanged();
        }
    }

    /**
     * Get the size of the selected items
     * @return int Count of selected items
     */
    public int getSelectedCount() {
        return mSelectedItemsIds.size();
    }

    /**
     * Get the list of te selected items
     * @return SparseBooleanArray Selected Item ids
     */
    public SparseBooleanArray getSelectedIds() {
        return mSelectedItemsIds;
    }
}
